7.4 auf 8.1.9 - Alte DB läuft nicht mit neuem PostgreSQL

Hi, ich habe folgendes Problem zu dem ich keine Lösung finde. Vielleicht hatte schon jemand von euch ein solches Problem.

Also, ich hatte eine Maschine auf der PostgreSQL 7.4 mit zwei Datenbanken lief. Diese Maschine ist leider kaputt - Festplatte hat sich aufgeraucht.

Nun habe ich einen neuen Server installiert mit Suse Linux 10.3 mit PostgreSQL 8.1.9. Nun wollte ich vom Backup die alte Datenbank (Verzeichnis data) einspielen und aber nun schimpft er, dass es ein altes Format ist. “pg_dumpall > SAVE” kann ich aber nicht ausführen, weil das System mit den alten Daten nicht kompatible ist. Wie komme ich nun an diese Datenbank?

Vielen Dank für eure Hilfe.

Die Lösung ist zu finden in: PostgreSQL: Documentation: Manuals: PostgreSQL 8.1: pg_dumpall

Hier findest Du folgendes geschrieben:

[html]
-i
–ignore-version

Ignore version mismatch between pg_dumpall and the database server.

pg_dumpall can handle databases from previous releases of PostgreSQL, but very old versions are not supported anymore (currently prior to 7.0). Use this option if you need to override the version check (and if pg_dumpall then fails, don’t say you weren’t warned). [/html]

Laut Doku sollte es also funktionieren.



mfg

fristo

Klingt so, als ob Du kein Backup (Dump) der DB, sondern ein Filesystembackup hast. In diesem Fall ist es wohl am einfachsten, erst einmal dieselbe Version von PG zu installieren und zu versuchen, diese mit den alten Daten zum laufen zu bringen. PG sollte aber tunlichst exakt gleich kompiliert sein, weil das Binärformat der Daten nicht kompatibel zwischen Versionen und wohl auch Plattformen ist.

Andreas

Ich hoffe zusätzlich, dass das “data” Verzeichnis nicht im laufenden Betrieb kopiert wurde. Sonst kannst du es eigentlich gleich wegwerfen.

Richtig, ich hab nur ein Filesystembackup! Okay, aber wo bekomme ich Postgresql 7.4 für Suse Linux 10.1 her? Ich finde keine passende rpm?

pg_dumpall -i > db.out
funktioniert nämlich nicht - leider.

Du wirst um selber compilieren wohl nicht herumkommen.

So, ich hab das alte System soweit hinbekommen, dass ich einen Dump machen konnte. Nun will ich diesen Dump zurück spielen aber bekomme folgende Fehlermeldung vom jungfreulichen postgres:

psql: FATAL:  Ident-Authentifizierung für Benutzer »postgres« fehlgeschlagen

Ja, und? Wer oder was hindert Dich, die pg_hba.conf anzupassen oder aber zum User ‘postgres’ zu werden?
Wer hindert Dich, mal nachzulesen, wie das alles geht?
PostgreSQL: Documentation: Manuals: PostgreSQL 8.2: Client Authentication

Andreas